import request from "../plugins/request";

/** 获取省市区 */
export const api_sysAreaQueryAllProvince = (params: any) => {
  return request({
    url: `/edu-app/open/sysArea/queryAllProvince`,
    method: "get",
    params: params,
  } as any);
};

/** 收获地址列表 */
export const api_userReceiveAddressPage = (params: any) => {
  return request({
    url: `/edu-app/userReceiveAddress/page`,
    method: "post",
    data: params,
  } as any);
};

/** 新增收获地址 */
export const api_userReceiveAddressSave = (params: any) => {
  return request({
    url: `/edu-app/userReceiveAddress/save`,
    method: "post",
    data: params,
  } as any);
};

/** 新增收获地址 */
export const api_userReceiveAddressUpdate = (params: any) => {
  return request({
    url: `/edu-app/userReceiveAddress/update`,
    method: "post",
    data: params,
  } as any);
};


/** 删除收获地址 */
export const api_userReceiveAddressRemove = (params: any) => {
  return request({
    url: `/edu-app/userReceiveAddress/remove?id=${params.id}`,
    method: "post",
  } as any);
};

/** 收获地址详情 */
export const api_userReceiveAddressDetail = (params: any) => {
  return request({
    url: `/edu-app/userReceiveAddress/detail`,
    method: "get",
    params: params,
  } as any);
};


/** 查询受益人详情 */
export const api_userBeneficiaryDetail = (params: any) => {
  return request({
    url: `/edu-app/userBeneficiary/detail/${params.id}`,
    method: "get"
  } as any);
};


/** 查询受益人列表 */
export const api_userBeneficiaryPage = (params: any) => {
  return request({
    url: `/edu-app/userBeneficiary/page`,
    method: "post",
    data: params,
  } as any);
};


/** 新增受益人 */
export const api_userBeneficiarySave = (params: any) => {
  return request({
    url: `/edu-app/userBeneficiary/save`,
    method: "post",
    data: params,
  } as any);
};

/** 修改受益人 */
export const api_userBeneficiaryUpdate = (params: any) => {
  return request({
    url: `/edu-app/userBeneficiary/update`,
    method: "post",
    data: params,
  } as any);
};

/** 删除受益人 */
export const api_userBeneficiaryRemove = (params: any) => {
  return request({
    url: `/edu-app/userBeneficiary/remove`,
    method: "get",
    data: params,
  } as any);
};

/** 获取学校列表 */
export const api_schoolAreaList = (params: any) => {
  return request({
    url: `/edu-app/open/schoolArea/list`,
    method: "post",
    data: params,
  } as any);
};

/** 获取地区学校详情 */
export const api_schoolAreaDetail = (params: any) => {
  return request({
    url: `/edu-app/open/schoolArea/detail/${params.id}`,
    method: "get"
  } as any);
};
